#include "counter.h"
//#include "io.h"

uint32_t tick_count = 0;
uint16_t ms_count = 0;
uint8_t sec_count = 0;
uint8_t min_count = 0;
uint8_t hour_count = 0;
uint16_t day_count = 0;


uint16_t beep_duration;
uint16_t alarm_counter;

ISR(TIMER0_COMP_vect)		//    0 -  
{
	if (beep_duration) beep_duration--;		//  
	else 
	{
		BEEP_OFF();
		TCCR0 = 0;	//  
	}
}

void beep_ms(uint16_t dur)
{
	beep_duration = dur;
	BEEP_ON();
	
	//   1, 2
	// clk = Fcpu/64, mode = CTC, freq = 1 kHz
	TCCR0 = (1<<WGM01)|(1<<CS01)|(1<<CS00);	
	OCR0 = F_CPU/64/1000;
	TIMSK |= 1<<OCIE0;
}


ISR(TIMER2_COMP_vect)
{
	ms_count++;
	tick_count++;

	if(ms_count == 1000)
	{
		++sec_count;
		ms_count = 0;
		
		if(sec_count == 60)
		{
			++min_count;
			sec_count = 0;
			
			if(min_count == 60)
			{
				++hour_count;
				min_count =0;
				
				if (hour_count == 24)
				{
					++day_count;
					hour_count = 0;
				}
			}
		}
	}
}


void counter_init()
{
//	   3
	// clk = Fcpu/128, mode = CTC, freq = 1 kHz
	TCCR2 = (1<<WGM21)|(1<<CS22)|(1<<CS20);	
	OCR2 = F_CPU/128/1000;
	TIMSK |= 1<<OCIE2;
/*	
	//   1, 2
	// clk = Fcpu/64, mode = CTC, freq = 1 kHz
	TCCR2 = (1<<WGM21)|(1<<CS21)|(1<<CS20);	
	OCR2 = F_CPU/64/1000;
	TIMSK |= 1<<OCIE2;
*/	
}
