/*
 * Created: 08.03.2014
 *  Author: Gnitiev V.P.
 *
 * Optimization - O2
 */

#include "ds1307.h"



u08 bcd_to_bin(u08 inn)
{
	return ( (inn & 0x0F) + 10*( (inn>>4) & 0x0F) );
}


 u08 bin_to_bcd(u08 inn)
{
	return ((inn / 10) << 4) | (inn % 10);
}


u08 ds1307_start_clock(void)
{
// !!!!      . !!!
	u08 temp_[2] = {0, 0};
		
	ds1307.error |= i2c_start(); 						//   START
	ds1307.error |= i2c_write(0xD0, temp_, 1); 		//   
	ds1307.error |= i2c_stop();						//	  STOP
	
	ds1307.error |= i2c_start(); 						//   START
	ds1307.error |= i2c_read(0xD0, &temp_[1], 1);		//  
	ds1307.error |= i2c_stop();						//	  STOP

	// temp_[0] = 0; -  
	temp_[1] = temp_[1] & 0x7F; 					//    -    

	ds1307.error |= i2c_start(); 						//   START
	ds1307.error |= i2c_write(0xD0, temp_, 2);		//  
	ds1307.error |= i2c_stop();						//	  STOP
	
	return ds1307.error;
}


u08 ds1307_stop_clock(void)
{
	u08 temp_[2] = {0, 0};
	
	ds1307.error |= i2c_start(); 						//   START
	ds1307.error |= i2c_write(0xD0, temp_, 1);  		//   
	ds1307.error |= i2c_stop();						//	  STOP

	ds1307.error |= i2c_start(); 						//   START
	ds1307.error |= i2c_read(0xD0, temp_[1], 1);		//  
	ds1307.error |= i2c_stop();						//	  STOP
	
	// temp_[0] = 0; -  
	temp_[1] = temp_[1] | 0x80; 					//    -  
	
	ds1307.error |= i2c_start(); 						//   START
	ds1307.error |= i2c_write(0xD0, temp_, 2);		//  
	ds1307.error |= i2c_stop();						//	  STOP

	return ds1307.error;
}


u08 ds1307_read(void)
{
	u08 read_data[64];		//7
	u08 adr = 0;
	u08 *p_in = read_data;
	u08 *p_out = &ds1307;

	ds1307.error |= i2c_start(); 										//   START
	ds1307.error |= i2c_write(0xD0, &adr, 1); 							//   
	ds1307.error |= i2c_stop();											//	  STOP
	
	ds1307.error |= i2c_start(); 										//   START
	ds1307.error |= i2c_read(0xD0, read_data, 64);						//  64 a
	ds1307.error |= i2c_stop();											//	  STOP

	for (u08 i=0; i<7; i++) *(p_out + i) = bcd_to_bin( *(p_in + i) );	//   
	
	for (u08 i=7; i<64; i++) *(p_out + i) =  *(p_in + i);				//    control, ram

	return ds1307.error;
}


u08 ds1307_write(void)
{
	u08 write_data[1+64];
	u08 *p_out = write_data;
	u08 *p_in = &ds1307;

	write_data[0] = 0; 														//  

	for (u08 i=0; i<7; i++)	*(p_out + 1 + i) = bin_to_bcd( *(p_in + i) );	//     
	
	for (u08 i=7; i<64; i++) *(p_out + 1 + i) =  *(p_in + i);				//      control, ram

	ds1307.error |= i2c_start(); 											//   START
	ds1307.error |= i2c_write(0xD0, write_data, 1+64);
	ds1307.error |= i2c_stop();												//	  STOP
	
	return ds1307.error;
}


u08 ds1307_write_control(void)
{
	u08 temp_[2] = {0x07, 0};						
		
	temp_[1] = ds1307.control;
		
	ds1307.error |= i2c_start(); 					//   START
	ds1307.error |= i2c_write(0xD0, temp_, 2); 		//    007     
	ds1307.error |= i2c_stop();						//	  STOP

	return ds1307.error;
}


u08 ds1307_write_ram(void)
{
	u08 write_data[1+56];
	u08 *p_out = write_data;
	u08 *p_in = &ds1307.ram;

	write_data[0] = 0x08; 													//  
	
	for (u08 i=0; i<56; i++) *(p_out + 1 + i) =  *(p_in + i);				//      control, ram

	ds1307.error |= i2c_start(); 											//   START
	ds1307.error |= i2c_write(0xD0, write_data, 1+56);
	ds1307.error |= i2c_stop();												//	  STOP
	
	return ds1307.error;
}
