#pragma once			//         

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "types.h"

#define MICROLAN_DDR			DDRD	//
#define	MICROLAN_PIN			PIND	//   
#define MICROLAN_PORT			PORTD	//
#define	MICROLAN_BIT			PC2		//   

#define	N_DEVICE_MAX			16		//      ( : ~14     )
#define COUNT_TRY_READ			10		//   ,   CRC

#define ERR_NO_DEVICE			0xFF	//  
#define ERR_COMPARE_CRC			0xCC	//     
#define ERR_UNKNOW				0xEE	//  /
#define ERR_OK					0x00	//  

#define	SIGNATURE_DS18B20		0x28	//   DS18B20
#define	SIGNATURE_DS1820		0x10	//   DS1820

extern u08 ds18x20_count;				//     


struct 
{
	u64 id;								//   - CRC  7 ,  -   (ds18x20 - 0x10),  -   
	u08 error;							//   
	float temperature;					//    
} ds18x20_array[N_DEVICE_MAX];			//  

void ds18x20_start_convert(void);		//   
void ds18x20_all_read(void);			//     

u08 microlan_search_id(void);			//     ( ,   id  ds18x20_array[])
u64 microlan_read_id(void);				//   (  ,     )

