/*
 * Created: 02.03.2014
 *  Author: Gnitiev V.P.
 *
 * Optimization - O2
 */

#include <avr/pgmspace.h>
#include "http.h"
#include "led_displey.h"	//     
#include "ds1307.h"			//       
#include "counter.h"		//     
#include "io.h"

u08 flag = 0;


// UDP callbacks



void udp_packet(eth_frame_t *frame, uint16_t len)				
{
// ,    UDP-. frame   . len    UDP- 
// (  UDP-,  ).  ,           .
/*
uint8_t udp_send(eth_frame_t *frame, uint16_t len)				
{
//    UDP-. frame   . len    .   , 
//     : IP- ,  ,  ,  . 
//  MAC-   ,   0    ,  
// ARP-.      	
}

//    UDP-.          .  
//      udp_packet ( ,   ).
void udp_reply(eth_frame_t *frame, uint16_t len);				
{
	
}	
*/
}

// TCP callbacks

uint8_t tcp_listen(uint8_t id, eth_frame_t *frame)
{
// ,      .    ,   
//  . id    (  ,     
// ), frame     ,   	

	ip_packet_t *ip = (void*)(frame->data);
	tcp_packet_t *tcp = (void*)(ip->data);

	if(tcp->to_port == htons(80)) return 1;
	else return 0;
}	

void tcp_closed(uint8_t id, uint8_t hard)					
{
// ,    . id    , 
// hard    ,     (graceful close).	

	
}

void tcp_write(uint8_t id, eth_frame_t *frame, uint16_t len)
{
// ,      TCP. id   , frame     , 
// len     

	ip_packet_t *ip = (void*)(frame->data);
	tcp_packet_t *tcp = (void*)(ip->data);
	char *req = (void*)tcp_get_data(tcp);

	if(!len) return;

	flag = 1;
	
	wdt_reset();
	
//  1	 
	if ( (strstr_P(req, PSTR("GET /?CH1=OFF"))) ) 
	{
		 CH1_OFF();
		 ch1 = DISABLE;
		 return;
	}	
 
	if ( (strstr_P(req, PSTR("GET /?CH1=ON")))  )
	{
		 CH1_ON();
		 ch1 = ENABLE;
		 beep_ms(BEEP_DUR_CH_ON);
		 return;
	}	
//  2	
		if ( (strstr_P(req, PSTR("GET /?CH2=OFF"))) ) 
	{
		 CH2_OFF();
		 ch2 = DISABLE;
		 return;
	}	
 
	if ( (strstr_P(req, PSTR("GET /?CH2=ON")))  )
	{
		 CH2_ON();
		 ch2 = ENABLE;
		 beep_ms(BEEP_DUR_CH_ON);
		 return;
	}	
//  3	
	if ( (strstr_P(req, PSTR("GET /?CH3=OFF"))) ) 
	{
		 CH3_OFF();
		 ch3 = DISABLE;
		 return;
	}	
 
	if ( (strstr_P(req, PSTR("GET /?CH3=ON")))  )
	{
		 CH3_ON();
		 ch3 = ENABLE;
		 beep_ms(BEEP_DUR_CH_ON);
		 return;
	}
//  	
	if ( (strstr_P(req, PSTR("GET /?BEEP=OFF"))) ) 
	{
		 BEEP_OFF();
		 beep = DISABLE;
		 return;
	}	
 
	if ( (strstr_P(req, PSTR("GET /?BEEP=ON")))  )
	{
		 BEEP_ON();
		 beep = ENABLE;
		 return;
	}

	if ( (strstr_P(req, PSTR("GET /?BEEP=SHORT")))  )
	{
		 beep_ms(BEEP_DUR_SHOT);
		 return;
	}
	
	wdt_reset();
	
//    - 	
	if ( (strstr_P(req, PSTR("GET /?MODE=TIME")))  )
	{
		 mode = TIME_MODE;
		 ds1307_write();
		 return;
	}
//    - 		
	if ( (strstr_P(req, PSTR("GET /?MODE=PRES")))  )
	{
		 mode = PRESS_MODE;
		 ds1307_write();
		 return;
	}
//    - 		
	if ( (strstr_P(req, PSTR("GET /?MODE=TERM")))  )
	{
		 mode = TEMP_MODE;
		 ds1307_write();
		 return;
	}	
//    -  	
	if ( (strstr_P(req, PSTR("GET /?MODE=NORM")))  )
	{
		 mode = NORM_MODE;
		 ds1307_write();
		 return;
	}	
// 
	if ( (strstr_P(req, PSTR("GET /?ALARM=ON")))  )
	{
		 alarm_active = ENABLE;
		 ds1307_write();	
		 return;
	}
	
	if ( (strstr_P(req, PSTR("GET /?ALARM=OFF")))  )
	{
		 alarm_active = DISABLE;
		 ds1307_write();	
		 return;
	}
	
	wdt_reset();
	
//  		
	if ( (strstr_P(req, PSTR("GET /?time_h=")))  )
	{
		u08 a[3];
		http_get_param_to_u08(req, 3, &a);
		
		if ( (a[0]<24)&&(a[1]<60)&&(a[2]<60) )
		{
			ds1307.hours = a[0];
			ds1307.minutes = a[1];
			ds1307.second = a[2];	
			
			ds1307_write();		
			beep_ms(BEEP_DUR_CH_ON);
		}		
		return;
	}
//   	
	if ( (strstr_P(req, PSTR("GET /?ch_time=")))  )
	{

		u08 a;
		http_get_param_to_u08(req, 1, &a);
		
		if ( (a>0)&&(a<=60) )
		{
			ch_time = a;
//			ds1307.ram[0] = a;
			ds1307_write();		
		}		
		return;
	}
// 	
	if ( (strstr_P(req, PSTR("GET /?brigh=")))  )
	{

		u08 a;
		http_get_param_to_u08(req, 1, &a);
		
		if ( (a>0)&&(a<100) )
		{
			brightness = a;
			ds1307.ram[1] = a;
			ds1307_write();		
		}		
		return;
	}
//  
	if ( (strstr_P(req, PSTR("GET /?alarm_h=")))  )
	{

		u08 a[2];
		http_get_param_to_u08(req, 2, &a);
		
		if ( (a[0]<24)&&(a[1]<60) )
		{
			alarm_h = a[0];
			alarm_m = a[1];
			
			ds1307_write();		
			beep_ms(BEEP_DUR_CH_ON);
		}		
		return;
	}

}


void http_get_param_to_u08(char *req, u08 n, u08 *param)
{
//    n         param[],   =   

	char *p;
	
	for (u08 i=0; i<n; i++)
	{
		p = strchr(req, '=');					//   ""   
		*p = ' ';								//   ""      ( )
		p++;									//     -    
		
		s16 temp = atoi(p);						//     
		
		if ( (temp >= 0)&&(temp <= 255) ) *(param+i) = temp;
	}
};



void tcp_read(uint8_t id, eth_frame_t *frame, uint8_t re)
{
/* , ,       TCP.  , 
	  ,
	   (  tcp_write),
	     .
	  (  re),     ,     
  .   */	
	
//	if (re) tcp_data(id, frame);
	if (flag) 
	{
		tcp_data(id, frame);
		flag = 0;
	}		
}

void http_reply_send(u08 id, eth_frame_t *frame, char *http_data, u08 pack_type)
{
	ip_packet_t *ip = (void*)(frame->data);
    tcp_packet_t *tcp = (void*)(ip->data);
	u16 len_str;	
	char http_reply[HTTP_MAXLEN_PACKET+10];
	
	wdt_reset();
	
	if (pack_type == HTTP_HEAD_PACKET)		//  - 
	{
	//   HTTP,     html  -    (Chunked transfer encoding)
		len_str = sprintf(http_reply, "HTTP/1.1 200 OK\r\nContent-Type: text/html; charset=windows-1251\r\nTransfer-Encoding: chunked\r\n\r\n");																																		
	}	
	else									//  
	{
		len_str = sprintf(http_reply, "%x\r\n%s\r\n", strlen(http_data), http_data);		
	}
	
	memcpy(tcp->data, http_reply, len_str);
	_delay_ms(2);
	tcp_send(id, frame, len_str, TCP_CONNECT_HOLD);

	if (pack_type == HTTP_END_PACKET)		//    
	{
		//     -   
		len_str = sprintf(http_reply, "0\r\n\r\n");
		memcpy(tcp->data, http_reply, len_str);
		_delay_ms(2);
		tcp_send(id, frame, len_str, TCP_OPTION_CLOSE);
	}
	//_delay_ms(2);
}


void tcp_data(uint8_t id, eth_frame_t *frame) //    
{
	char http_data[HTTP_MAXLEN_PACKET];
	char str_temp[32];
	u32 req_time = up_time_sec;

//     	
	wdt_reset();
	http_reply_send(id, frame, http_data, HTTP_HEAD_PACKET);

//   
	wdt_reset();
	strcpy_P(http_data, PSTR("<HEAD><TITLE> </TITLE></HEAD>"));																							//    
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//  ,   
	wdt_reset();
	strcpy_P(http_data, PSTR("<TABLE BORDER align=center BGCOLOR=00FF00><TR><TD align=center><b></b></TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	strcpy_P(http_data, PSTR("<TD align=center><b></b></TD><TD align=center><b></b></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//    
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b></b>,::</TD><TD align=center> "));												//    
	sprintf(str_temp, "%d : %02d : %02d", ds1307.hours, ds1307.minutes, ds1307.second);												//    
	strcat(http_data, str_temp);																									//  
	strcat_P(http_data, PSTR("</TD><TD>"));																							//    
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=get align=center><INPUT type=TEXT name=time_h size=3 value=0>:<INPUT type=TEXT name=time_m size=3 value=0>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	strcpy_P(http_data, PSTR(":<INPUT type=TEXT name=time_s size=3 value=0> <INPUT type=SUBMIT value=></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//     
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b> </b>,:</TD><TD align=center>"));												
	sprintf(str_temp, "%d : %02d", alarm_h, alarm_m);												
	strcat(http_data, str_temp);																									
	strcat_P(http_data, PSTR("</TD><TD>"));																							
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=get align=center><INPUT type=TEXT name=alarm_h size=3 value=0>:<INPUT type=TEXT name=alarm_m size=3 value=0>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	strcpy_P(http_data, PSTR("<INPUT type=SUBMIT value=></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//  
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b></b></TD><TD align=center>"));
	if (alarm_active) strcat_P(http_data, PSTR("<b>.</b>"));
	else strcat_P(http_data, PSTR("."));
	strcat_P(http_data, PSTR("</TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=GET align=center><INPUT type=SUBMIT name=ALARM value=ON><INPUT type=SUBMIT name=ALARM value=OFF></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	
//    
	wdt_reset();
	if (!bmp180_read())
	{
		strcpy_P(http_data, PSTR("<TR><TD><b></b>,  ..</TD><TD align=center>"));
		sprintf(str_temp,"%d,%d", (int)bmp180.pressure_mmHg, (int)((int)(10*bmp180.pressure_mmHg) % 10) ); 
		strcat(http_data, str_temp);
		strcat_P(http_data, PSTR("</TD><TD align=center>BMP180</TD></TR>"));
		http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	}
	

//     
	wdt_reset();
	if (ds18x20_count)
	{
		strcpy_P(http_data, PSTR("<TR><TD><b> </b>, </TD><TD align=center>"));
		sprintf(str_temp,"%d", ds18x20_count); 
		strcat(http_data, str_temp);
		strcat_P(http_data, PSTR("</TD><TD align=center>DS18x20</TD></TR>"));
		http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	}	
	
//      
	for (u08 i=0; i<ds18x20_count; i++)
	{
		
		s08 t_ = (int)((int)(10*ds18x20_array[i].temperature) % 10);
		if (t_<0) t_=-t_;
		u32 hid = ds18x20_array[i].id >> 32;
		u32 lid = ds18x20_array[i].id  & 0xFFFFFFFF;
			
		strcpy_P(http_data, PSTR("<TR><TD><b>["));
		sprintf(str_temp,"%d", i+1);
		strcat(http_data, str_temp);
		strcat_P(http_data, PSTR("]</b>, </TD><TD align=center>"));
			
		sprintf(str_temp,"%d,%d", (int)ds18x20_array[i].temperature, t_); 
		strcat(http_data, str_temp);		
		strcat_P(http_data, PSTR("</TD><TD align=center>"));
		http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);	
		
		strcpy_P(http_data, PSTR("ID: "));
		sprintf(str_temp,"%08lX%08lX", hid, lid); 
		strcat(http_data, str_temp);
		strcat_P(http_data, PSTR("</TD></TR>"));
		http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);	
	}

//        ( )
	wdt_reset();
	if (!bmp180.error)
	{
		strcpy_P(http_data, PSTR("<TR><TD><b> </b>, </TD><TD align=center>"));
		sprintf(str_temp,"%d,%d", (int)bmp180.temperature, (int)((int)(10*bmp180.temperature) % 10)); 
		strcat(http_data, str_temp);
		strcat_P(http_data, PSTR("</TD><TD align=center>BMP180</TD></TR>"));
		http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	}	

//    
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b></b>, %</TD><TD align=center>"));
	sprintf(str_temp,"%d", brightness); 
	strcat(http_data, str_temp);
	strcat_P(http_data, PSTR(" </TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=get align=center><INPUT type=TEXT name=brigh size=3 value=50><INPUT type=SUBMIT value=></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//      
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b>  </b>, .</TD><TD align=center>"));
	sprintf(str_temp,"%d", ds1307.ram[0]); 
	strcat(http_data, str_temp);
	strcat_P(http_data, PSTR(" </TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=get align=center><INPUT type=TEXT name=ch_time size=3 value=2><INPUT type=SUBMIT value=></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//       
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b> 1</b></TD><TD align=center>"));
	if (ch1) strcat_P(http_data, PSTR("<b>.</b>"));
	else strcat_P(http_data, PSTR("."));
	strcat_P(http_data, PSTR("</TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=GET align=center><INPUT type=SUBMIT name=CH1 value=ON><INPUT type=SUBMIT name=CH1 value=OFF></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b> 2</b></TD><TD align=center>"));
	if (ch2) strcat_P(http_data, PSTR("<b>.</b>"));
	else strcat_P(http_data, PSTR("."));
	strcat_P(http_data, PSTR("</TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=GET align=center><INPUT type=SUBMIT name=CH2 value=ON><INPUT type=SUBMIT name=CH2 value=OFF></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b> 3</b></TD><TD align=center>"));
	if (ch3) strcat_P(http_data, PSTR("<b>.</b>"));
	else strcat_P(http_data, PSTR("."));
	strcat_P(http_data, PSTR("</TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=GET align=center><INPUT type=SUBMIT name=CH3 value=ON><INPUT type=SUBMIT name=CH3 value=OFF></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//       
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b> </b></TD><TD align=center>"));
	if (beep) strcat_P(http_data, PSTR("<b>.</b>"));
	else strcat_P(http_data, PSTR("."));
	strcat_P(http_data, PSTR("</TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=GET align=center><INPUT type=SUBMIT name=BEEP value=ON><INPUT type=SUBMIT name=BEEP value=OFF>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	strcpy_P(http_data, PSTR("<INPUT type=SUBMIT name=BEEP value=SHORT></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//      
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b> </b></TD><TD align=center>"));
	if (mode == NORM_MODE) strcat_P(http_data, PSTR(""));
	if (mode == PRESS_MODE) strcat_P(http_data, PSTR(""));
	if (mode == TIME_MODE) strcat_P(http_data, PSTR(""));
	if (mode == TEMP_MODE) strcat_P(http_data, PSTR(""));
	strcat_P(http_data, PSTR("</TD><TD>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	wdt_reset();
	strcpy_P(http_data, PSTR("<FORM method=GET align=center><INPUT type=SUBMIT name=MODE value=NORM><INPUT type=SUBMIT name=MODE value=TIME>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);
	strcpy_P(http_data, PSTR("<INPUT type=SUBMIT name=MODE value=PRES><INPUT type=SUBMIT name=MODE value=TERM></FORM></TD></TR>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);

//    ,  
	wdt_reset();
	strcpy_P(http_data, PSTR("<TR><TD><b>  </b></TD><TD align=center>"));
	sprintf(str_temp,"%d ., %d ., %d .", day_count, hour_count, min_count); 
	strcat(http_data, str_temp);
	strcat_P(http_data, PSTR("</TD><TD></TD></TR></TABLE>"));
	http_reply_send(id, frame, http_data, HTTP_NOEND_PACKET);


//  ""
	wdt_reset();
	strcpy_P(http_data, PSTR("<BR><FORM method=get align=center><INPUT type=SUBMIT value=></FORM>"));
	http_reply_send(id, frame, http_data, HTTP_END_PACKET);
}
