/*
 * Created: 08.03.2014
 *  Author: Gnitiev V.P.
 *
 * Optimization - O2
 */

#include "i2c.h"

u08 i2c_start(void)
{
	u08 temp;

	if (TWSR == 0x00) TWCR = (1 << TWINT) | (1 << TWSTO);	//     -     (  )

	TWBR = (F_CPU/F_SCL-16)/2;		//         

	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN) & (~(1 << TWSTO)); // | (1 << TWEA) ; 	//  ,  ,  ,   
	while ( !(TWCR & (1<<TWINT)) ) { };	//    

	temp = TWSR & 0xF8;

	if ( (temp == 0x08) || (temp == 0x10) )  return 0;					//      
	return temp;
}

u08 i2c_stop(void)
{
	u08 temp;

	TWCR = (1 << TWINT) | (1 << TWSTO)  | (1 << TWEN); 

	_delay_us(10);

	temp = TWSR & 0xF8;
	if (temp == 0xF8) return 0;
	if (temp == 0x00) return 0xFF;
	return temp;
}


u08 i2c_write(u08 sla, u08 *send_buf, u08 count)
{
	u08 now_byte;
	u08 temp;

//   
	TWDR = (sla & 0b11111110); //0xD0; 	// - (SLA-W)  
	TWCR = (1 << TWEN) | (1 << TWINT);	//  
	while ( !(TWCR & (1<<TWINT)) );		//    

	temp = TWSR & 0xF8;
	if ( (temp != 0x18) && (temp != 0x28) ) return temp;		//   ,     

//  
	now_byte = 0; 
	while (now_byte < count)
	{
	//  
		TWDR = *(send_buf + now_byte);	//    
		TWCR = (1 << TWEN) | (1 << TWINT);//  
		while ( !(TWCR & (1<<TWINT)) );	//    

		temp = TWSR & 0xF8;
		if (temp != 0x28) return temp;	//   ,     

		now_byte++;
	}

	return 0;
}


u08 i2c_read(u08 sla, u08 *data, u08 count)
{
	u08 now_byte;
	u08 temp;

	if (sla)							//   0     
	{
	//     
		TWDR = (sla | 0b00000001);			// - (SLA-R)  
		TWCR = (1 << TWEN) | (1 << TWINT) ;	//  
		while ( !(TWCR & (1<<TWINT)) );		//    

		temp = TWSR & 0xF8;
		if ( (temp != 0x40) && (temp != 0x28) ) return temp;		//   ,     
	}

//  
	now_byte = 0; 
	while (now_byte < count)
	{
	//  
		if ( now_byte != (count - 1) )
		{	//    -    (1 << TWEA)
			TWCR = (1 << TWINT) | (1 << TWEA) | (1 << TWEN); 		//  
			while ( !(TWCR & (1<<TWINT)) ) { };						//    

			temp = TWSR & 0xF8;
			if ((temp != 0x50) && (temp != 0x28)) return temp;				//   ,     

			*(data + now_byte) = TWDR; 					// 
		}

		if (now_byte == (count - 1) )
		{	//   -     (~(1 << TWEA))
			TWCR = (1 << TWINT) | (1 << TWEN) & (~(1 << TWEA)); 	//  
			while ( !(TWCR & (1<<TWINT)) ) { };						//    

			temp = TWSR & 0xF8;
			if ( (temp != 0x58) && (temp != 0x28) ) return temp;				//   ,     

			*(data + now_byte) = TWDR; 					// 
		}
		now_byte++;
	}

	return 0;
}



