/*
 * Created: 08.11.2013
 *  Author: Gnitiev V.P.
 *
 * Optimization - O2
 *   1 ( )
 */

#include <avr/io.h>
#include <util/delay.h>

#include "types.h"
#include "led_displey.h"

#define CODE_MINUS		0x40							//  
#define CODE_DEGREE		0x63							//  
#define CODE_SPACE		0x00							//  
#define CODE_H			0x76							//  H
#define CODE_P			0x73							//  P

u08 brightness = 50;									// 

const u08 ind_code[16] = { 0x3F,0x6,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71 };
			/*
			.db 0x3F,!0x3F; 0	;    
			.db 0x06,!0x06; 1	;               A
			.db 0x5B,!0x5B; 2	;             #####
			.db 0x4F,!0x4F; 3	;            #     #
			.db 0x66,!0x66; 4	;          F-#     #-B
			.db 0x6D,!0x6D; 5	;            #     #
			.db 0x7D,!0x7D; 6	;           G-#####
			.db 0x07,!0x07; 7	;            #     #
			.db 0x7F,!0x7F; 8	;          E-#     #-C
			.db 0x6F,!0x6F; 9	;            #     #
			.db 0x77,!0x77; A	;             #####   ##
			.db 0x7C,!0x7C; b	;               D      #-H
			.db 0x39,!0x39; C	
			.db 0x5E,!0x5E; d	3F,6,5B,4F,66,6D,7D,07,7F,6F,77,7C,39,5E,79,71
			.db 0x79,!0x79; E	
			.db 0x71,!0x71; F	

			.db 0x40,!0x40; 	
			.db 0x63,!0x63; 
			.db 0x00,0xFF; 
			*/


void displey(u08 *ind_array, u08 count, u08 min_on_dig)
{
	SDT_DDR |= (1 << SDT_PIN);
	C1_DDR |= (1 << C1_PIN);
	C2_OE_DDR |= (1 << C2_OE_PIN);
	
	//	 - 

//	TCCR1B |= (1 << CS10);											//    = F_cpu

	TCCR1A |= (1 << WGM10) | (1 << WGM11); 	TCCR1B |= (1 << WGM12);	//  - Fast PWM 10 bit
		
	TCCR1A |= (1 << COM1A1) | (1 << COM1A0);						//   - 		

	OCR1A = 10 * brightness;										//     0  100   10 

	
	if (min_on_dig < 1) min_on_dig = 1;								//  1   
	
	for (u08 i=1; i<=count-min_on_dig; i++)							//   	
	{
//		if ( (ind_array[count-i] & 0x7F) > 0x0F) continue;			//      ,  ,     (  )
		if ( (ind_array[count-i] & 0x7F) > 9) continue;				//      ,  ,     (  )
		if (ind_array[count-i] == 0) ind_array[count-i] = ' ';		//    0   -    ()
		else break;
	}
	
	//   -  ,      
	TCCR1B &= ~(1 << CS10);	
	
	for (u08 k=0; k<count; k++)
	{
		u08 temp = *(ind_array+(count-1-k)) ;
		u08 s = ind_code[ temp & 0x7F ];
		
		if (temp == '-') s = CODE_MINUS;							//  
		if (temp == '*') s = CODE_DEGREE;							//  
		if (temp == ' ') s = CODE_SPACE;							//  
		if (temp == 'H') s = CODE_H;								//  H
		if (temp == 'P') s = CODE_P;								//  P
		if (temp == '.') s = PSET;									//  .
		
		s |= temp & PSET;											//  
		
		for (u08 i=0; i<8; i++)										//     
		{
			SDT_PORT &= ~(1 << SDT_PIN);
			if (s & 0x80) SDT_PORT |= (1 << SDT_PIN);
		
			SDT_PORT |= (1 << C1_PIN);
			s <<= 1;	
			SDT_PORT &= ~(1 << C1_PIN); 
		}		
	}	

	C2_OE_PORT |= (1 << C2_OE_PIN);	
	C2_OE_PORT &= ~(1 << C2_OE_PIN);	
	
	//  
	TCCR1B |= (1 << CS10);	
}

void displey_test(void)
{
	u08 a[4] = {0x88, 0x88, 0x88, 0x88};

	displey(&a, 4, 1);				//     
	_delay_ms(1000);
}

void ind_temperature(float temperature)
{
	u08 a[4];
	s16 temp;

	if ((temperature > 125) || (temperature < -55))								//     
	{
		a[0] = '-';
		a[1] = '-';
		a[2] = '-';
		a[3] = '-';
					
		displey(&a, 4, 1);
					
		return;
	}

	a[0] = '*';
	temp = 10 * temperature;
	
	if ( (temperature >= 0) && (temperature < 100) )
	{
		a[1] = (temp ) % 10;														// x 0,1
		a[2] = (temp /10) % 10 | PSET;												// 
		a[3] = (temp /100) % 10;													// 
	}
	
	if ( temperature >= 100 )
	{
		a[0] = (temp) % 10;															// x 0,1
		a[1] = (temp /10) % 10 | PSET;												// 
		a[2] = (temp /100) % 10;													// 
		a[3] = (temp) / 1000;														// 
	}
	
	temp = -temp;
	
	if ( (temperature < 0) && (temperature > -10) )
	{
		a[1] = (temp ) % 10;														// x 0,1
		a[2] = (temp /10) % 10 | PSET;												// 
		a[3] = '-';																	// -
	}
	if ( temperature <= -10 )
	{
		a[0] = (temp ) % 10;														// x 0,1
		a[1] = (temp /10) % 10 | PSET;												// 
		a[2] = (temp /100) % 10;													// 
		a[3] = '-';																	// -
	}
	
	displey(&a, 4, 1);
			
}

void ind_number_sensor(u08 n)
{
	u08 a[4];	
	
	a[0] = n % 10;
	a[1] = (n /10) % 10;
	a[2] = (n /100) % 10;
	a[3] = 0x0D;										
	
	displey(&a, 4, 1);
}

/*
void ind_humidity(float humidity)
{
	u16 temp = 0;
	u08 a[4];

	temp = 10 * humidity;

	a[0] = ( temp ) % 10;						
	a[1] = ( temp /10) % 10 | PSET;
	a[2] = ( temp /100) % 10;
	a[3] = 'H';
	
	displey(&a, 4);
}
*/

void ind_pressure(float pressure)
{
	u08 a[4];
	s16 temp;

	temp =  pressure;	
 
	a[0] = temp % 10;
	a[1] = (temp /10) % 10;
	a[2] = (temp /100) % 10;
	a[3] = 'P';

	displey(&a, 4, 1);
}

