/*
 * Created: 02.03.2014 13:31
 *  Author: Gnitiev V.P.
 *
 * Optimization - O2
 * #define	F_CPU	16000000		// properties\Toolchain\Symbols [add] F_CPU=16000000
 */ 

#include "ds18x20.h"
#include "led_displey.h"
#include "http.h"
#include "ds1307.h"
#include "bmp180.h"
#include "io.h"
#include "types.h"
#include "counter.h"

//   ,   
u08	display_duration_temperature;
u08	display_duration_time;
u08	display_duration_pressure;

void __delay_ms(u16 x)
{
	u32 temp = tick_count + x;
	
	wdt_reset();
	
	while (tick_count < temp) 
	{
		lan_poll(); 
		wdt_reset();
	}
}

void u08_inc(u08 *x, u08 min, u08 max)
{
	u08 temp;
	
	temp = *x;
	temp++;
	if (temp > max) temp = min;
	*x = temp; 
}

void u08_dec(u08 *x, u08 min, u08 max)
{
	u08 temp;
	
	temp = *x;
	temp--;
	if (temp < min) temp = max;
	if ( (temp == 255)&&(min == 0) ) temp = max;
	*x = temp; 
}

void displey_temperarure(void)
{
	u08 a[4];
	ds18x20_all_read();

	for (u08 i=0; i<ds18x20_count; i++)
	{
//   		
		if (ds18x20_count > 2)											//    2,      
		{			
			ind_number_sensor(i+1);										//   
			for (u08 j=0; j<DISPLEY_DURATION_NUMBER; j++) __delay_ms(1000); 
		}	
//  ,   - - - -	
		if (ds18x20_array[i].error) 		
		{
			a[0] = '-';
			a[1] = '-';
			a[2] = '-';
			a[3] = '-';
			displey(&a, 4, 1);										//   
		}
//    -  
		else ind_temperature(ds18x20_array[i].temperature);			//  
		__delay_ms(1000); 
	} //for i
		
	microlan_search_id();
	wdt_reset();
	ds18x20_start_convert();
	wdt_reset();
}


void displey_time(void)
{
	u08 a[4];
	
	if ( ds1307_read() ) return;
	a[0] = ds1307.minutes % 10 | 0x80;						// c   
	a[1] = (ds1307.minutes /10) % 10;
	a[2] = ds1307.hours % 10;
	a[3] = (ds1307.hours /10) % 10;											
	displey(&a, 4, 3);	

	__delay_ms(500);
		
	if ( ds1307_read() ) return;
	a[0] = ds1307.minutes % 10;								// c   
	a[1] = (ds1307.minutes /10) % 10;
	a[2] = ds1307.hours % 10;
	a[3] = (ds1307.hours /10) % 10;											
	displey(&a, 4, 3);			
	
	__delay_ms(500);
}	

void displey_pressure(void)
{
	if (bmp180_read()) return;

	ind_pressure(bmp180.pressure_mmHg);

	__delay_ms(1000);
}

void klv_hendler(void)
{
	u08 a[4] = {' ', ' ', ' ', ' '};
	
	wdt_reset();
	
//   	
	
	if ( B_MODE_PRESS )		
	{
		beep_ms(BEEP_DUR_KEY);
		mode++;
		ds1307_write();
		
		if ( mode > END_MODE ) 
		{
			beep_ms(500);
			mode = NORM_MODE;
			ds1307_write();
			displey(&a, 4, 1);		//      - ,   
			wdt_reset();
			__delay_ms(500);
		}	
	}
	
//  +		

	if ( B_PLUS_PRESS )		
	{	
		beep_ms(BEEP_DUR_KEY);
		
		switch (mode)
		{
			case H_MODE:	u08_inc(&ds1307.hours, 0, 23);		break;
			case M_MODE:	u08_inc(&ds1307.minutes, 0, 59);	break;
			case I_MODE:	u08_inc(&brightness, 1, 99);		break;		
			case CH_MODE:	u08_inc(&ch_time, 1, 60);			break;
		}
		ds1307.ram[1] = brightness;
		ds1307_write();
	}
	
//  -		

	if ( B_MINUS_PRESS )	
	{
		beep_ms(BEEP_DUR_KEY);
		
		switch (mode)
		{
			case H_MODE:	u08_dec(&ds1307.hours, 0, 23);		break;
			case M_MODE:	u08_dec(&ds1307.minutes, 0, 59);	break;
			case I_MODE:	u08_dec(&brightness, 1, 99);		break;
			case CH_MODE:	u08_dec(&ch_time, 1, 60);			break;
			case TIME_MODE:	 
			{
				if (ds1307.minutes > 29) u08_dec(&ds1307.hours, 0, 23);		// 
				ds1307.minutes = 0;
				ds1307.second = 0;
			}
		}
		ds1307.ram[1] = brightness;
		ds1307_write();
	}	

	wdt_reset();
}	

void displey_all(void)
{
	u08 a[4];
	
	wdt_reset();
	
	switch (mode){										//   
	
		case H_MODE:									//     
			a[0] = '.';
			a[1] = ' ';
			a[2] = bin_to_bcd (ds1307.hours) & 0x0F;
			a[3] = ( bin_to_bcd (ds1307.hours) & 0xF0 ) >> 4;
			displey(&a, 4, 3);
			__delay_ms(400);
			break;
		
		case M_MODE:									//     
			a[0] = bin_to_bcd (ds1307.minutes) & 0x0F | 0x80;
			a[1] = (bin_to_bcd (ds1307.minutes) & 0xF0 ) >> 4;
			a[2] = ' ';
			a[3] = ' ';
			displey(&a, 4, 2);	
			__delay_ms(400);
			break;	

		case I_MODE:									//   
			a[0] = bin_to_bcd (brightness) & 0x0F;
			a[1] = ( bin_to_bcd (brightness) & 0xF0 ) >> 4;
			a[2] = ' ';
			a[3] = 0x01;								// I
			displey(&a, 4, 1);
			__delay_ms(400);
			break;

		case CH_MODE:									//    
			a[0] = bin_to_bcd (ch_time) & 0x0F;
			a[1] = ( bin_to_bcd (ch_time) & 0xF0 ) >> 4;
			a[2] = ' ';
			a[3] = 0x0C;								// C
			displey(&a, 4, 1);
			__delay_ms(400);
			break;

		case PRESS_MODE:								//  
			displey_pressure();
			break;
		
		case TIME_MODE:									//  
			displey_time();
			break;

		case TEMP_MODE:									//  
			displey_temperarure();
			break;

		default:										//       
			if (display_duration_time > 0)
			{
				display_duration_time--;
				displey_time();
				
				if (display_duration_time == 0) 
				{
					display_duration_temperature = ch_time;
					
					if (ds18x20_count > 1) display_duration_temperature = 1;	//          
				}					
			}

			if (display_duration_temperature > 0)
			{
				display_duration_temperature--;
				displey_temperarure();
				
				if (display_duration_temperature == 0) display_duration_pressure = ch_time;		
			}		

			if (display_duration_pressure > 0)
			{
				display_duration_pressure--;
				displey_pressure();
				
				if (display_duration_pressure == 0) display_duration_time = ch_time;	
			}		

			break;
				
	 }// switch
}

int main()
{
	u08 temp = 0;
	u08 a[4];
	
	mode = NORM_MODE;		//  
	ch_time = 2;			//  
	
	display_duration_temperature	= 1;
	display_duration_time			= 0;
	display_duration_pressure		= 0;

	BEEP_OFF();

	ds1307_start_clock();											//  
	
	temp =  microlan_search_id() ;									//   , 
	ds18x20_start_convert();										//     
	
	wdt_reset();
	wdt_enable(WDTO_2S);

	displey_test();													//    ()  
	wdt_reset();

	a[0] = temp & 0x0F;												//   
	a[1] = temp >> 4;
	a[2] = 0;
	a[3] = 0x0D;
	displey(&a, 4, 1);												//   
	
	_delay_ms(1000);
	wdt_reset();
	
	B_R_ON(); 														//    
	
	ds1307_read();

	brightness = ds1307.ram[1];
	
	counter_init();
	lan_init();

	sei();
	
	beep_ms(100);													//   
	
	while(1) 
	{

		klv_hendler();
		displey_all();
		
		if ( alarm_active && (ds1307.hours == alarm_h) && (ds1307.minutes == alarm_m) )  beep_ms(ALARM_DURATION);
		
		for (u08 i=0; i<200; i++) 
		{
			wdt_reset();
			lan_poll(); 
		}			

	}		
	return 0;
}
